package org.kie.kogito.app;

import org.kie.kogito.Config;
import org.kie.kogito.uow.UnitOfWorkManager;

@org.springframework.stereotype.Component()
public class Application implements org.kie.kogito.Application {

    @org.springframework.beans.factory.annotation.Autowired(required = false)
    java.util.List<org.kie.kogito.event.EventPublisher> eventPublishers;

    @org.springframework.beans.factory.annotation.Value("${kogito.service.url:#{null}}")
    java.util.Optional<java.lang.String> kogitoService;

    @org.springframework.beans.factory.annotation.Autowired()
    org.kie.kogito.Config config;

    Processes processes = new Processes(this);

    public Config config() {
        return config;
    }

    public UnitOfWorkManager unitOfWorkManager() {
        return config().process().unitOfWorkManager();
    }

    @javax.annotation.PostConstruct()
    public void setup() {
        if (config().process() != null) {
            if (eventPublishers != null) {
                eventPublishers.forEach(publisher -> unitOfWorkManager().eventManager().addPublisher(publisher));
            }
            unitOfWorkManager().eventManager().setService(kogitoService.orElse(""));
            unitOfWorkManager().eventManager().setAddons(config().addons());
        }
    }

    public Processes processes() {
        return processes;
    }
}
