package org.kie.kogito.app;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import org.kie.kogito.Model;
import org.kie.kogito.process.Process;
import org.kie.kogito.process.Processes;

@org.springframework.stereotype.Component()
public class ApplicationProcesses implements Processes {

    @org.springframework.beans.factory.annotation.Autowired()
    java.util.List<org.kie.kogito.process.Process<? extends org.kie.kogito.Model>> processes;

    private Map<String, Process<? extends Model>> mappedProcesses = new HashMap<>();

    @javax.annotation.PostConstruct
    public void setup() {
        for (Process<? extends Model> process : processes) {
            mappedProcesses.put(process.id(), process);
        }
    }

    public Process<? extends Model> processById(String processId) {
        return mappedProcesses.get(processId);
    }

    public Collection<String> processIds() {
        return mappedProcesses.keySet();
    }
}
